using System;

namespace Transfuzija
{
    class Program
    {
        static void Main(string[] args)
        {
            int N = int.Parse(Console.ReadLine());
            string[] J = Console.ReadLine().Split();
            string[] KG = { "O", "A", "B", "AB" };
            int[] Jed = new int[4];
            for(int i = 0; i < 4; i++)
            {
                Jed[i] = int.Parse(J[i]);
            }
            string[] Pot = new string[N];
            int[] Po = new int[N];
            for(int i = 0; i < N; i++)
            {
                string[] u = Console.ReadLine().Split();
                Pot[i] = u[0];
                Po[i] = int.Parse(u[1]);
            }

        }
    }
}